// C++ Vererbung: Geom. Objekte mit zusammengesetzten Objekten
// Hauptprogramm
//
// Aufruf: main
//
// Klaus Kusche, 2011

#include "color.hxx"
#include "bigobj.hxx"
#include "rect.hxx"
#include "circ.hxx"
#include "comp.hxx"

#include "sdlinterf.h"

#include <cstdlib>
#include <ctime>

using namespace std;

const int numObjects = 12;

int main(void)
{
  srand(time(NULL));
  sdlInit();

  {
    Comp *faces[numObjects];
    faces[0] = new Comp(400,300,7);
    faces[0]->add(&Circ(Color(255,255,0),400,300,80,100));
    faces[0]->add(&Circ(Color(200,100,0),400,300,10,30));
    faces[0]->add(&Circ(Color(0,0,255),360,280,25,25));
    faces[0]->add(&Circ(Color(0,0,255),440,280,25,25));
    faces[0]->add(&Circ(Color(255,0,0),400,350,40,10));
    faces[0]->add(&Circ(Color(255,200,0),310,290,10,40));
    faces[0]->add(&Circ(Color(255,200,0),490,290,10,40));
    faces[0]->setZ(numObjects);
    faces[0]->scale(30, 30);
    for (int i = 1; i < numObjects; ++i) {
      faces[i] = new Comp(*faces[0]);
      faces[i]->setPos(rand() % (SDL_X_SIZE - 140) + 70,
                       rand() % (SDL_Y_SIZE - 140) + 70);
      faces[i]->setZ(i);
    }
    BigObj::drawAll();
    sdlUpdate();
    for (;;) {
      sdlMilliSleep(20);
      for (int i = 0; i < numObjects; ++i) {
        if (faces[i]->getY() > SDL_Y_SIZE - 70) {
          faces[i]->setPos(rand() % (SDL_X_SIZE - 140) + 70,
                           rand() % (SDL_Y_SIZE - 140) + 70);
          faces[i]->rotate();
          faces[i]->rotate();
        } else {
          faces[i]->move(0, 1);
        }
      }
      BigObj::drawAll();
      sdlUpdate();
    }
  }

  sdlExit();
  exit(EXIT_SUCCESS);
}
